<?php
/**
 * Construction Firm functions and definitions
 *
 * @subpackage Construction Firm
 * @since 1.0
 */


//theme setup
function construction_firm_setup() {
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'responsive-embeds' );
	add_theme_support( 'woocommerce' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'construction-firm-featured-image', 2000, 1200, true );
	add_image_size( 'construction-firm-thumbnail-avatar', 100, 100, true );


	load_theme_textdomain( 'construction-firm', get_template_directory() . '/languages' );

	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'construction-firm' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height'  => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css', construction_firm_fonts_url() ) );

	if ( ! defined( 'CONSTRUCTION_FIRM_SUPPORT' ) ) {
		define('CONSTRUCTION_FIRM_SUPPORT',__('https://wordpress.org/support/theme/construction-firm/','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_REVIEW' ) ) {
		define('CONSTRUCTION_FIRM_REVIEW',__('https://wordpress.org/support/theme/construction-firm/reviews/','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_LIVE_DEMO' ) ) {
	define('CONSTRUCTION_FIRM_LIVE_DEMO',__('https://trial.ovationthemes.com/construction-firm/','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_BUY_PRO' ) ) {
	define('CONSTRUCTION_FIRM_BUY_PRO',__('https://www.ovationthemes.com/products/construction-wordpress-theme','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_PRO_DOC' ) ) {
	define('CONSTRUCTION_FIRM_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-construction-firm-pro-doc/','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_FREE_DOC' ) ) {
	define('CONSTRUCTION_FIRM_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-construction-firm-free-doc/','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_THEME_NAME' ) ) {
	define('CONSTRUCTION_FIRM_THEME_NAME',__('Premium Construction Theme','construction-firm'));
	}
	if ( ! defined( 'CONSTRUCTION_FIRM_BUNDLE_LINK' ) ) {
	define('CONSTRUCTION_FIRM_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','construction-firm'));
	}
	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
}
add_action( 'after_setup_theme', 'construction_firm_setup' );

//woocommerce//
//shop page no of columns
function construction_firm_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'construction_firm_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'construction_firm_woocommerce_loop_columns' );
function construction_firm_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'construction_firm_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'construction_firm_woocommerce_products_per_page' );
// related products
function construction_firm_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'construction_firm_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'construction_firm_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'construction_firm_related_products_args' );

// breadcrumb seperator
function construction_firm_woocommerce_breadcrumb_separator($construction_firm_defaults) {
    $construction_firm_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $construction_firm_defaults['delimiter'] = $construction_firm_separator;

    return $construction_firm_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'construction_firm_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($construction_firm_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $construction_firm_classes = array_merge(['wow','zoomIn'], $construction_firm_classes);
	    }
	    return $construction_firm_classes;
	},10,3);
}
//woocommerce-end//

// Get start function

// Enqueue scripts and styles
function construction_firm_enqueue_admin_script($hook) {
    // Admin JS
    wp_enqueue_script('construction-firm-admin-js', get_theme_file_uri('/assets/js/construction-firm-admin.js'), array('jquery'), true);
    wp_localize_script(
		'construction-firm-admin-js',
		'construction_firm',
		array(
			'admin_ajax'	=>	admin_url('admin-ajax.php'),
			'wpnonce'			=>	wp_create_nonce('construction_firm_dismissed_notice_nonce')
		)
	);
	wp_enqueue_script('construction-firm-admin-js');

    wp_localize_script( 'construction-firm-admin-js', 'construction_firm_scripts_localize',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
}
add_action('admin_enqueue_scripts', 'construction_firm_enqueue_admin_script');

//dismiss function 
add_action( 'wp_ajax_construction_firm_dismissed_notice_handler', 'construction_firm_ajax_notice_dismiss_fuction' );

function construction_firm_ajax_notice_dismiss_fuction() {
	if (!wp_verify_nonce($_POST['wpnonce'], 'construction_firm_dismissed_notice_nonce')) {
		exit;
	}
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}

function construction_firm_excerpt_enabled(){
	if(get_theme_mod('construction_firm_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function construction_firm_string_limit_words($string, $word_limit) {
	$words = explode(' ', $string, ($word_limit + 1));
	if(count($words) > $word_limit)
	array_pop($words);
	return implode(' ', $words);
}

//get start box
function construction_firm_custom_admin_notice() {
    // Check if the notice is dismissed
    if ( ! get_option('dismissed-get_started_notice', FALSE ) )  {
        // Check if not on the theme documentation page
        $construction_firm_current_screen = get_current_screen();
        $construction_firm_theme = wp_get_theme();
        $construction_firm_theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $construction_firm_theme->get( 'Name' ) ) );
		$construction_firm_demo_page_slug = apply_filters( $construction_firm_theme_name . '_theme_setup_wizard_construction_firm_page_slug', $construction_firm_theme_name . '-wizard' );
		$construction_firm_expected_screen_id = 'appearance_page_' . $construction_firm_demo_page_slug;
        if ( $construction_firm_current_screen && $construction_firm_current_screen->id !== $construction_firm_expected_screen_id ) { ?>
            <div class="notice notice-info is-dismissible" data-notice="get_started_notice">
                <div class="notice-div">
                    <div>
                        <p class="theme-name"><?php echo esc_html($construction_firm_theme->get('Name')); ?></p>
                        <p><?php _e('For information and detailed instructions, check out our theme documentation.', 'construction-firm'); ?></p>
                    </div>
                    <div class="notice-buttons-box">
                        <a class="button-primary livedemo" href="<?php echo esc_url( CONSTRUCTION_FIRM_LIVE_DEMO ); ?>" target="_blank"><?php esc_html_e('Live Demo', 'construction-firm'); ?></a>
                        <a class="button-primary buynow" href="<?php echo esc_url( CONSTRUCTION_FIRM_BUY_PRO ); ?>" target="_blank"><?php esc_html_e('Get Pro Theme', 'construction-firm'); ?></a>
                        <a class="button-primary theme-install" href="<?php echo esc_url( 'themes.php?page=' . $construction_firm_demo_page_slug ); ?>"><?php _e( 'Begin Installation', 'construction-firm' ); ?></a>
                    </div>
                </div>
            </div>
        <?php
        }
    }
}
add_action('admin_notices', 'construction_firm_custom_admin_notice');
//after switch theme
add_action('after_switch_theme', 'construction_firm_after_switch_theme');
function construction_firm_after_switch_theme () {
    update_option('dismissed-get_started_notice', FALSE );
}
//get-start-function-end//

// tag count
function construction_firm_display_post_tag_count() {
    $construction_firm_tags = get_the_tags();
    $construction_firm_tag_count = ($construction_firm_tags) ? count($construction_firm_tags) : 0;
    $construction_firm_tag_text = ($construction_firm_tag_count === 1) ? 'tag' : 'tags';
    echo $construction_firm_tag_count . ' ' . $construction_firm_tag_text;
}

// Date formatting
function construction_firm_display_shop_date() {
    // Get the date type option
    $construction_firm_date_type = get_theme_mod( 'construction_firm_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $construction_firm_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $construction_firm_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $construction_firm_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $construction_firm_date_to_display );
}

//media post format
function construction_firm_get_media($construction_firm_type = array()){
	$construction_firm_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $construction_firm_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $construction_firm_content, $construction_firm_type );
    return $output;
  }
}

// front page template
function construction_firm_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'construction_firm_front_page_template' );

// excerpt function
function construction_firm_custom_excerpt() {
    $construction_firm_excerpt = get_the_excerpt();
    $construction_firm_plain_text_excerpt = wp_strip_all_tags($construction_firm_excerpt);
    
    // Get dynamic word limit from theme mod
    $construction_firm_word_limit = esc_attr(get_theme_mod('construction_firm_post_excerpt', '30'));
    
    // Limit the number of words
    $construction_firm_limited_excerpt = implode(' ', array_slice(explode(' ', $construction_firm_plain_text_excerpt), 0, $construction_firm_word_limit));

    echo esc_html($construction_firm_limited_excerpt);
}

// typography
function construction_firm_fonts_scripts() {
	$headings_font = esc_html(get_theme_mod('construction_firm_headings_text'));
	$body_font = esc_html(get_theme_mod('construction_firm_body_text'));

	if( $headings_font ) {
		wp_enqueue_style( 'construction-firm-headings-fonts', '//fonts.googleapis.com/css?family='. $headings_font );
	} else {
		wp_enqueue_style( 'construction-firm-source-sans', '//fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic');
	}
	if( $body_font ) {
		wp_enqueue_style( 'construction-firm-body-fonts', '//fonts.googleapis.com/css?family='. $body_font );
	} else {
		wp_enqueue_style( 'construction-firm-source-body', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300,400italic,700,600');
	}
}
add_action( 'wp_enqueue_scripts', 'construction_firm_fonts_scripts' );

// Footer Text
function construction_firm_copyright_link() {
    $construction_firm_footer_text = get_theme_mod('construction_firm_footer_text', esc_html__('Construction WordPress Theme', 'construction-firm'));
    $construction_firm_credit_link = esc_url('https://www.ovationthemes.com/products/free-construction-wordpress-theme');

    echo '<a href="' . $construction_firm_credit_link . '" target="_blank">' . esc_html($construction_firm_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'construction-firm') . '</span></a>';
}

// custom sanitizations
// dropdown
function construction_firm_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'construction_firm_sanitize_integer' ) ) {
	function construction_firm_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function construction_firm_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function construction_firm_sanitize_select( $construction_firm_input, $setting ){
    $construction_firm_input = sanitize_key($construction_firm_input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $construction_firm_input, $choices ) ? $construction_firm_input : $setting->default );
}
// toggle switch
function construction_firm_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function construction_firm_sanitize_choices( $construction_firm_input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $construction_firm_input, $control->choices ) ) {
        return $construction_firm_input;
    } else {
        return $setting->default;
    }
}
// phone number
function construction_firm_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function construction_firm_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

//widges
function construction_firm_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'construction-firm' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'construction-firm' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'construction-firm' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );
	register_sidebar( array(
		'name'          => __( 'Footer 1', 'construction-firm' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'construction-firm' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'construction-firm' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'construction-firm' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'construction-firm' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'construction_firm_widgets_init' );

// google fonts
function construction_firm_fonts_url(){
	$construction_firm_font_url = '';
	$construction_firm_font_family = array();
	$construction_firm_font_family[] = 'Inter:wght@100;200;300;400;500;600;700;800;900';
	$construction_firm_font_family[] = 'Open Sans:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;1,300;1,400;1,500;1,600;1,700;1,800';

	$construction_firm_query_args = array(
		'family'	=> rawurlencode(implode('|',$construction_firm_font_family)),
	);
	$construction_firm_font_url = add_query_arg($construction_firm_query_args,'//fonts.googleapis.com/css');
	return $construction_firm_font_url;
	$contents = wptt_get_webfont_url( esc_url_raw( $fonts_url ) );
}

// enque scrip and styles
function construction_firm_scripts() {

	// Add custom fonts, used in the main stylesheet.
	wp_enqueue_style( 'construction-firm-fonts', construction_firm_fonts_url(), array(), null );

	//Bootstarp
	wp_enqueue_style( 'construction-firm-bootstrap', get_template_directory_uri().'/assets/css/bootstrap.css' );

	// Theme stylesheet.
	wp_enqueue_style( 'construction-firm-style', get_stylesheet_uri() );

	wp_style_add_data('construction-firm-style', 'rtl', 'replace');

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'construction-firm-style',$construction_firm_custom_style );


	//font-awesome
	wp_enqueue_style( 'construction-firm-font-awesome', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	// Block Style
	wp_enqueue_style( 'construction-firm-block-style', esc_url( get_template_directory_uri() ).'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'construction-firm-custom-js', get_theme_file_uri( '/assets/js/construction-firm-custom.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'construction-firm-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );

	//Bootstarp JS
	wp_enqueue_script( 'construction-firm-bootstrap.js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('construction_firm_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'construction-firm-wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'construction-firm-animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'construction_firm_scripts' );

function construction_firm_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'construction-firm-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );

	// Add custom fonts.
	wp_enqueue_style( 'construction-firm-fonts', construction_firm_fonts_url(), array(), null );
}
add_action( 'enqueue_block_editor_assets', 'construction_firm_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'construction_firm_customize_controls_register_scripts' );
function construction_firm_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'construction-firm-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

// enque files
require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typofont.php' );
require_once get_theme_file_path( 'inc/wptt-webfont-loader.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require get_parent_theme_file_path( 'inc/sortable/sortable_control.php' );
